#include <iostream>
using namespace std;

unsigned long pot(unsigned long base, unsigned esp) {             // calcolo di base^esp
    if (esp) return base*pot(base, esp-1);
    return 1;
}
unsigned long ncr(unsigned n, unsigned k) {                       // calcolo di n su k
    if (k > n) return 0;
    if ((k == 0) || (k == n)) return 1;
    unsigned long prod = 1;
    for (unsigned x = n-k+1; x <= n; x++) prod *= x;
    for (unsigned x = 2; x <= k; x++) prod /= x;
    return prod;
}
int main() {
    unsigned n, a;
    unsigned long ok = 0, somma = 0;
    cout << "n = ";
    cin >> n;
    for (a = 0; a <= (n-(n % 2))/2; a++) somma += ncr(n-a-1, n-2*a+1) + 2*ncr(n-a-1, n-2*a) + ncr(n-a-1, n-2*a-1); // calcolo del risultato con la formula
    somma = pot(2, n) - (n % 2) - somma;
    cout << "\n" << somma << "\n";
    string s("");                                              // ricerca delle serie "buone" di lampadine fra tutte le possibili combinazioni
    for (unsigned long a = 0; a < pot(2, n); a++) {
        s = string("");
        unsigned k = a;
        do {
            s = ((k % 2)? "a" : "s") + s;
            k /= 2;
        } while (k);
        if (s.find("aa") != string::npos) ok++;
    }
    cout << ok << "\n";
    return 0;
}

